﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.Services;
using System.Security.Cryptography;
using System.Security;
using System.Text;
using System.Xml;
using System.Security.Cryptography.X509Certificates;
using System.IO;
using System.Security.Cryptography.Xml;

namespace Key_Management_Server
{
    /// <summary>
    /// Key Management Server:
    /// Run Command makecert -r -pe -n "CN=Encrypted_Mutlicasting_Chat" -b 01/07/2009 -e 01/01/2012 -sky exchange -ss my
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    public class Service1 : System.Web.Services.WebService
    {
        #region X509 Certificate
        // Encrypt The Generated Key Using The X509 Certificate
        private string EncryptTheKey(string Generated_Key)
        { 
            try
            {
                // Create an XmlDocument object.
                XmlDocument xmlDoc = new XmlDocument();
                xmlDoc.PreserveWhitespace = true;
                xmlDoc.LoadXml(Generated_Key);
                // Open the X.509 "Current User" store in read only mode.
                X509Store store = new X509Store(StoreLocation.LocalMachine);
                store.Open(OpenFlags.ReadOnly);
                // Place all certificates in an X509Certificate2Collection object.
                X509Certificate2Collection certCollection = store.Certificates;
                X509Certificate2 cert = null;
                // Loop through each certificate and find the certificate 
                // with the appropriate name.
                foreach (X509Certificate2 c in certCollection)
                {
                    if (c.Subject == "CN=Encrypted_Mutlicasting_Chat")
                    {
                        cert = c;
                        break;
                    }
                }
                if (cert == null)
                {
                    throw new CryptographicException("The X.509 certificate could not be found.");
                }
                // Close the store.
                store.Close();
                // Encrypt the "creditcard" element.
                Encrypt_Now(xmlDoc, "RSAKeyValue", cert);
                // return the Encrypted XML
                return xmlDoc.OuterXml;
            }
            catch (Exception ex)
            {
                 return ex.Message;
            }
        }
        private void Encrypt_Now(XmlDocument Doc, string ElementToEncrypt, X509Certificate2 Cert)
        { 
            // Check the arguments.  
            if (Doc == null)
                throw new ArgumentNullException("Doc");
            if (ElementToEncrypt == null)
                throw new ArgumentNullException("ElementToEncrypt");
            if (Cert == null)
                throw new ArgumentNullException("Cert");
            // Find the specified element in the XmlDocument
            // object and create a new XmlElemnt object.
            XmlElement elementToEncrypt = Doc.GetElementsByTagName(ElementToEncrypt)[0] as XmlElement;
            // Throw an XmlException if the element was not found.
            if (elementToEncrypt == null)
            {
                throw new XmlException("The specified element was not found");
            }
            // Create a new instance of the EncryptedXml class 
            // and use it to encrypt the XmlElement with the 
            // X.509 Certificate.
            EncryptedXml eXml = new EncryptedXml();

            // Encrypt the element.
            EncryptedData edElement = eXml.Encrypt(elementToEncrypt, Cert);

            // Replace the element from the original XmlDocument
            // object with the EncryptedData element.
            EncryptedXml.ReplaceElement(elementToEncrypt, edElement, false);
        }
        #endregion X509 Certificate

        #region Key Management
        // (CspParameters) Contains parameters that are passed 
        // to the cryptographic service provider (CSP)
        // to generate the public key
            CspParameters ServerKey;

        // (RSACryptoServiceProvider) Performs asymmetric encryption
        //  and decryption using the implementation of the RSA algorithm
        //  provided by the cryptographic service provider (CSP). 
            RSACryptoServiceProvider csp;

        [WebMethod]
        public string GetTheServerKey()
        {
            // Generate The Public Key By Using The RoomID 
            // And The Server MachineKey  
            ServerKey = new CspParameters();
            ServerKey.KeyContainerName = Environment.MachineName;
            ServerKey.Flags = CspProviderFlags.UseMachineKeyStore;
            ServerKey.KeyNumber = 1; // Type1: Exchange Key

            // Generate The Private Key and 
            // Return The Private and The Public Keys as XML Data 
            csp = new RSACryptoServiceProvider(ServerKey);
            return EncryptTheKey(csp.ToXmlString(true)); 
        }
        #endregion Key Management
    }



}
